Public oForm
oForm = Createobject('comboSample')
oForm.Show

Define Class ComboSample As Form

**************************************************
*-- Class:        cntsimplemover 
*-- ParentClass:  container
*-- BaseClass:    container
Define Class cntsimplemover As container

  Width = 409
  Height = 149
  BorderWidth = 0
  *-- stores x coordinate of mouse pointer position when left mouse button is depressed
  nmousex = 0
  *-- stores y coordinate of mouse pointer position when left mouse button is depressed
  nmousey = 0
  *-- Cursor when dropping is okay
  cdropicon = "DragMove.cur"
  cnodropicon = "NoDrop01.Cur"
  *-- number of pixels a user has to move the mouse with the left mouse button down for the StartDrag method to be called.
  ndragthreshold = 8
  Name = "cntsimplemover"


  Add Object lstsource As listbox With ;
    DragIcon = "..\graphics\dragmove.cur", ;
    FontSize = 9, ;
    Height = 144, ;
    Left = 0, ;
    MultiSelect = .T., ;
    Sorted = .T., ;
    TabIndex = 1, ;
    Top = 0, ;
    Width = 169, ;
    IntegralHeight = .T., ;
    Name = "lstSource"


  Add Object lstdestination As listbox With ;
    DragIcon = "..\graphics\dragmove.cur", ;
    FontSize = 9, ;
    Height = 144, ;
    Left = 240, ;
    MoverBars = .T., ;
    MultiSelect = .T., ;
    TabIndex = 2, ;
    Top = 0, ;
    Width = 169, ;
    IntegralHeight = .T., ;
    Name = "lstDestination"


  Add Object cmdmove As commandbutton With ;
    Top = 2, ;
    Left = 186, ;
    Height = 25, ;
    Width = 37, ;
    Picture = "..\graphics\moveone.bmp", ;
    TabIndex = 3, ;
    ToolTipText = "Move Selected Items", ;
    Name = "cmdMove"


  Add Object cmdmoveall As commandbutton With ;
    Top = 33, ;
    Left = 186, ;
    Height = 25, ;
    Width = 37, ;
    Picture = "..\graphics\moveall.bmp", ;
    TabIndex = 4, ;
    ToolTipText = "Move All Items", ;
    Name = "cmdMoveAll"


  Add Object cmdremove As commandbutton With ;
    Top = 81, ;
    Left = 186, ;
    Height = 25, ;
    Width = 37, ;
    Picture = "..\graphics\removeone.bmp", ;
    TabIndex = 5, ;
    ToolTipText = "Remove Selected Items", ;
    Name = "cmdRemove"


  Add Object cmdremoveall As commandbutton With ;
    Top = 112, ;
    Left = 186, ;
    Height = 25, ;
    Width = 37, ;
    Picture = "..\graphics\removeall.bmp", ;
    TabIndex = 6, ;
    ToolTipText = "Remove All Items", ;
    Name = "cmdRemoveAll"


  *-- Moves items from the source list to the destination list
  Procedure moveitems
    Lparameters toSource
    Local lnItem, toDestination, lnCol

    *** Initialize the destination list
    With This
      If toSource = .lstsource
        toDestination = .lstdestination
      Else
        toDestination = .lstsource
      Endif
    Endwith

    Thisform.LockScreen = .T.
    *** As items are removed from the list, its ListCount property becomes smaller
    *** So we use a while loop instead of a for loop so we can control the index
    lnItem = 1
    With toSource
      Do While lnItem <= .ListCount
        If .Selected[ lnItem ]
          ***********************************************************************
          *** Changed By.: Marcia G. Akins on 20 August 2005
          *** Reason.....: Make code more generic so we can have more than 2 columns
          ***********************************************************************
          toDestination.AddItem( .List[ lnItem, 1 ] )
          For lnCol = 2 To .ColumnCount
            toDestination.List[ toDestination.NewIndex, lnCol ] = .List[ lnItem, lnCol ]
          Endfor
          ***********************************************************************
          *** Changed By.: Marcia G. Akins on 27 November 2004
          *** Reason.....: added a hook to be able to do anything that needs done on the form when we move items
          ***********************************************************************
          This.AfterMoveItem( toDestination )
          ***********************************************************************
          .RemoveItem( lnItem )
        Else
          lnItem = lnItem + 1
        Endif
      Enddo
    Endwith
    Thisform.LockScreen = .F.
  Endproc


  *-- Starts the drag operation if the mouse has been held down long enough (after all, we don't want to be dragging items every time we click on one!)
  Procedure startdrag
    Lparameters toList, tnX, tnY
    With This
      *** Only begin the drag operation if the mouse has moved at least the minumun number pixels
      If Abs( tnX - .nmousex ) > .ndragthreshold Or ;
          ABS( tnY - .nmousey ) > .ndragthreshold
        toList.Drag()
      Endif
    Endwith
  Endproc


  *-- Changes the drag icon depending on whether or not the user is allowed to drop the item into the list box that the item is being dragged over
  Procedure changeicon
    Lparameters toSource, tnState
    If tnState = 0
      *** allowed to drop
      toSource.DragIcon = This.cdropicon
    Else
      If tnState = 1
        *** not allowed to drop
        toSource.DragIcon = This.cnodropicon
      Endif
    Endif
  Endproc


  *-- A place to put anything that must be done after an item is moved
  Procedure AfterMoveItem
    Lparameters toDestination
  Endproc


  Procedure Init
    If DoDefault()
      This.ResetLists()
    Endif

  Endproc


  *-- Populates the source list  and initializes the destination list (if necessary)
  Procedure ResetLists
  Endproc


  Procedure lstsource.DragOver
    Lparameters oSource, nXCoord, nYCoord, nState
    This.Parent.changeicon( oSource, nState )
  Endproc


  Procedure lstsource.DblClick
    This.Parent.moveitems( This )
  Endproc


  Procedure lstsource.DragDrop
    Lparameters oSource, nXCoord, nYCoord
    If oSource.Name # This.Name
      This.Parent.moveitems( oSource )
    Endif
  Endproc


  Procedure lstsource.MouseDown
    Lparameters nButton, nShift, nXCoord, nYCoord
    This.Parent.nmousex = nXCoord
    This.Parent.nmousey = nYCoord
  Endproc


  Procedure lstsource.MouseMove
    Lparameters nButton, nShift, nXCoord, nYCoord
    *** If the user has moved the mouse while the left mouse button is depressed,
    *** check to see if we reall should begin the drag operation or have we merely
    *** clicked on an item?
    If nButton = 1
      This.Parent.startdrag( This, nXCoord, nYCoord )
    Endif
  Endproc


  Procedure lstdestination.DragOver
    Lparameters oSource, nXCoord, nYCoord, nState
    This.Parent.changeicon( oSource, nState )
  Endproc


  Procedure lstdestination.DblClick
    This.Parent.moveitems( This )
  Endproc


  Procedure lstdestination.DragDrop
    Lparameters oSource, nXCoord, nYCoord
    If oSource.Name # This.Name
      This.Parent.moveitems( oSource )
    Endif
  Endproc


  Procedure lstdestination.MouseDown
    Lparameters nButton, nShift, nXCoord, nYCoord
    This.Parent.nmousex = nXCoord
    This.Parent.nmousey = nYCoord
  Endproc


  Procedure lstdestination.MouseMove
    Lparameters nButton, nShift, nXCoord, nYCoord
    *** If the user has moved the mouse while the left mouse button is depressed,
    *** check to see if we reall should begin the drag operation or have we merely
    *** clicked on an item?
    If nButton = 1
      This.Parent.startdrag( This, nXCoord, nYCoord )
    Endif
  Endproc


  Procedure cmdmove.click
    This.Parent.moveitems( This.Parent.lstsource )
  Endproc


  Procedure cmdmoveall.click
    Local lnItem, lnCol

    Thisform.LockScreen = .T.
    With This.Parent
      For lnItem = 1 To .lstsource.ListCount
        .lstdestination.AddItem( .lstsource.List[ lnItem, 1 ] )
        ***********************************************************************
        *** Changed By.: Marcia G. Akins on 20 August 2005
        *** Reason.....: Allow for more than 2 columns in the lists
        ***********************************************************************
        For lnCol = 1 To .lstsource.ColumnCount
          .lstdestination.List[ .lstDestination.NewIndex, lnCol ] = .lstsource.List[ lnItem, lnCol ]
        Endfor
        .AfterMoveItem( .lstdestination )
      Endfor
      .lstsource.Clear
    Endwith
    Thisform.LockScreen = .F.
  Endproc


  Procedure cmdremove.click
    This.Parent.moveitems( This.Parent.lstdestination )
  Endproc


  Procedure cmdremoveall.click
    Local lnItem, lnCol

    Thisform.LockScreen = .T.
    With This.Parent
      For lnItem = 1 To .lstdestination.ListCount
        .lstsource.AddItem( .lstdestination.List[ lnItem, 1 ] )
        ***********************************************************************
        *** Changed By.: Marcia G. Akins on 20 August 2005
        *** Reason.....: Allow for more than 2 columns in the lists
        ***********************************************************************
        For lnCol = 1 To .lstdestination.ColumnCount
          .lstsource.List[ .lstSource.NewIndex, lnCol ] = .lstdestination.List[ lnItem, lnCol ]
        Endfor
      Endfor
      .lstdestination.Clear
    Endwith
    Thisform.LockScreen = .F.
  Endproc


Enddefine

**************************************************
*-- Class:        cntsimplemover 
*-- ParentClass:  container
*-- BaseClass:    container
Define Class cntsimplemover As container

  Width = 409
  Height = 149
  BorderWidth = 0
  *-- stores x coordinate of mouse pointer position when left mouse button is depressed
  nmousex = 0
  *-- stores y coordinate of mouse pointer position when left mouse button is depressed
  nmousey = 0
  *-- Cursor when dropping is okay
  cdropicon = "DragMove.cur"
  cnodropicon = "NoDrop01.Cur"
  *-- number of pixels a user has to move the mouse with the left mouse button down for the StartDrag method to be called.
  ndragthreshold = 8
  Name = "cntsimplemover"


  Add Object lstsource As listbox With ;
    DragIcon = "..\graphics\dragmove.cur", ;
    FontSize = 9, ;
    Height = 144, ;
    Left = 0, ;
    MultiSelect = .T., ;
    Sorted = .T., ;
    TabIndex = 1, ;
    Top = 0, ;
    Width = 169, ;
    IntegralHeight = .T., ;
    Name = "lstSource"


  Add Object lstdestination As listbox With ;
    DragIcon = "..\graphics\dragmove.cur", ;
    FontSize = 9, ;
    Height = 144, ;
    Left = 240, ;
    MoverBars = .T., ;
    MultiSelect = .T., ;
    TabIndex = 2, ;
    Top = 0, ;
    Width = 169, ;
    IntegralHeight = .T., ;
    Name = "lstDestination"


  Add Object cmdmove As commandbutton With ;
    Top = 2, ;
    Left = 186, ;
    Height = 25, ;
    Width = 37, ;
    Picture = "..\graphics\moveone.bmp", ;
    TabIndex = 3, ;
    ToolTipText = "Move Selected Items", ;
    Name = "cmdMove"


  Add Object cmdmoveall As commandbutton With ;
    Top = 33, ;
    Left = 186, ;
    Height = 25, ;
    Width = 37, ;
    Picture = "..\graphics\moveall.bmp", ;
    TabIndex = 4, ;
    ToolTipText = "Move All Items", ;
    Name = "cmdMoveAll"


  Add Object cmdremove As commandbutton With ;
    Top = 81, ;
    Left = 186, ;
    Height = 25, ;
    Width = 37, ;
    Picture = "..\graphics\removeone.bmp", ;
    TabIndex = 5, ;
    ToolTipText = "Remove Selected Items", ;
    Name = "cmdRemove"


  Add Object cmdremoveall As commandbutton With ;
    Top = 112, ;
    Left = 186, ;
    Height = 25, ;
    Width = 37, ;
    Picture = "..\graphics\removeall.bmp", ;
    TabIndex = 6, ;
    ToolTipText = "Remove All Items", ;
    Name = "cmdRemoveAll"


  *-- Moves items from the source list to the destination list
  Procedure moveitems
    Lparameters toSource
    Local lnItem, toDestination, lnCol

    *** Initialize the destination list
    With This
      If toSource = .lstsource
        toDestination = .lstdestination
      Else
        toDestination = .lstsource
      Endif
    Endwith

    Thisform.LockScreen = .T.
    *** As items are removed from the list, its ListCount property becomes smaller
    *** So we use a while loop instead of a for loop so we can control the index
    lnItem = 1
    With toSource
      Do While lnItem <= .ListCount
        If .Selected[ lnItem ]
          ***********************************************************************
          *** Changed By.: Marcia G. Akins on 20 August 2005
          *** Reason.....: Make code more generic so we can have more than 2 columns
          ***********************************************************************
          toDestination.AddItem( .List[ lnItem, 1 ] )
          For lnCol = 2 To .ColumnCount
            toDestination.List[ toDestination.NewIndex, lnCol ] = .List[ lnItem, lnCol ]
          Endfor
          ***********************************************************************
          *** Changed By.: Marcia G. Akins on 27 November 2004
          *** Reason.....: added a hook to be able to do anything that needs done on the form when we move items
          ***********************************************************************
          This.AfterMoveItem( toDestination )
          ***********************************************************************
          .RemoveItem( lnItem )
        Else
          lnItem = lnItem + 1
        Endif
      Enddo
    Endwith
    Thisform.LockScreen = .F.
  Endproc


  *-- Starts the drag operation if the mouse has been held down long enough (after all, we don't want to be dragging items every time we click on one!)
  Procedure startdrag
    Lparameters toList, tnX, tnY
    With This
      *** Only begin the drag operation if the mouse has moved at least the minumun number pixels
      If Abs( tnX - .nmousex ) > .ndragthreshold Or ;
          ABS( tnY - .nmousey ) > .ndragthreshold
        toList.Drag()
      Endif
    Endwith
  Endproc


  *-- Changes the drag icon depending on whether or not the user is allowed to drop the item into the list box that the item is being dragged over
  Procedure changeicon
    Lparameters toSource, tnState
    If tnState = 0
      *** allowed to drop
      toSource.DragIcon = This.cdropicon
    Else
      If tnState = 1
        *** not allowed to drop
        toSource.DragIcon = This.cnodropicon
      Endif
    Endif
  Endproc


  *-- A place to put anything that must be done after an item is moved
  Procedure AfterMoveItem
    Lparameters toDestination
  Endproc


  Procedure Init
    If DoDefault()
      This.ResetLists()
    Endif

  Endproc


  *-- Populates the source list  and initializes the destination list (if necessary)
  Procedure ResetLists
  Endproc

  PROCEDURE lstSource.Init
    This.AddItem("Penn")
  endproc

  Procedure lstsource.DragOver
    Lparameters oSource, nXCoord, nYCoord, nState
    This.Parent.changeicon( oSource, nState )
  Endproc


  Procedure lstsource.DblClick
    This.Parent.moveitems( This )
  Endproc


  Procedure lstsource.DragDrop
    Lparameters oSource, nXCoord, nYCoord
    If oSource.Name # This.Name
      This.Parent.moveitems( oSource )
    Endif
  Endproc


  Procedure lstsource.MouseDown
    Lparameters nButton, nShift, nXCoord, nYCoord
    This.Parent.nmousex = nXCoord
    This.Parent.nmousey = nYCoord
  Endproc


  Procedure lstsource.MouseMove
    Lparameters nButton, nShift, nXCoord, nYCoord
    *** If the user has moved the mouse while the left mouse button is depressed,
    *** check to see if we reall should begin the drag operation or have we merely
    *** clicked on an item?
    If nButton = 1
      This.Parent.startdrag( This, nXCoord, nYCoord )
    Endif
  Endproc



  PROCEDURE lstDestination.Init
    This.AddItem("Penn")
  ENDPROC
  
  Procedure lstdestination.DragOver
    Lparameters oSource, nXCoord, nYCoord, nState
    This.Parent.changeicon( oSource, nState )
  Endproc


  Procedure lstdestination.DblClick
    This.Parent.moveitems( This )
  Endproc


  Procedure lstdestination.DragDrop
    Lparameters oSource, nXCoord, nYCoord
    If oSource.Name # This.Name
      This.Parent.moveitems( oSource )
    Endif
  Endproc


  Procedure lstdestination.MouseDown
    Lparameters nButton, nShift, nXCoord, nYCoord
    This.Parent.nmousex = nXCoord
    This.Parent.nmousey = nYCoord
  Endproc


  Procedure lstdestination.MouseMove
    Lparameters nButton, nShift, nXCoord, nYCoord
    *** If the user has moved the mouse while the left mouse button is depressed,
    *** check to see if we reall should begin the drag operation or have we merely
    *** clicked on an item?
    If nButton = 1
      This.Parent.startdrag( This, nXCoord, nYCoord )
    Endif
  Endproc


  Procedure cmdmove.click
    This.Parent.moveitems( This.Parent.lstsource )
  Endproc


  Procedure cmdmoveall.click
    Local lnItem, lnCol

    Thisform.LockScreen = .T.
    With This.Parent
      For lnItem = 1 To .lstsource.ListCount
        .lstdestination.AddItem( .lstsource.List[ lnItem, 1 ] )
        ***********************************************************************
        *** Changed By.: Marcia G. Akins on 20 August 2005
        *** Reason.....: Allow for more than 2 columns in the lists
        ***********************************************************************
        For lnCol = 1 To .lstsource.ColumnCount
          .lstdestination.List[ .lstDestination.NewIndex, lnCol ] = .lstsource.List[ lnItem, lnCol ]
        Endfor
        .AfterMoveItem( .lstdestination )
      Endfor
      .lstsource.Clear
    Endwith
    Thisform.LockScreen = .F.
  Endproc


  Procedure cmdremove.click
    This.Parent.moveitems( This.Parent.lstdestination )
  Endproc


  Procedure cmdremoveall.click
    Local lnItem, lnCol

    Thisform.LockScreen = .T.
    With This.Parent
      For lnItem = 1 To .lstdestination.ListCount
        .lstsource.AddItem( .lstdestination.List[ lnItem, 1 ] )
        ***********************************************************************
        *** Changed By.: Marcia G. Akins on 20 August 2005
        *** Reason.....: Allow for more than 2 columns in the lists
        ***********************************************************************
        For lnCol = 1 To .lstdestination.ColumnCount
          .lstsource.List[ .lstSource.NewIndex, lnCol ] = .lstdestination.List[ lnItem, lnCol ]
        Endfor
      Endfor
      .lstdestination.Clear
    Endwith
    Thisform.LockScreen = .F.
  Endproc


Enddefine

Enddefine
